#ifndef __Aip4cComponents_Aip4cPlugin_h__
#define __Aip4cComponents_Aip4cPlugin_h__

#include <Aip4cComponents/Aip4cComponents.h>
#include <Aip4cComponents/Aip4cWidget.h>
#include <Aip4cComponents/PluginInfo.h>

#include <vector>

namespace Aip4cComponents
{
	class Aip4cComponents_Export Aip4cPlugin
	{
		public:
#if		defined (LINUX)
		typedef void* Handle;
#elif defined (_WINDOWS)
			typedef HMODULE Handle;
#endif /* LINUX */

		private:
			Handle _handle;
			std::string _strSO;
			Aip4cComponents::Aip4cWidget* (*_createAip4cWidget)( Aip4cComponents::Aip4cWindow* pparent );
			const Aip4cComponents::PluginInfo& (*_pluginInfo)();

		public:
			Aip4cPlugin( const std::string& strSO = std::string() );
			Aip4cPlugin( const Aip4cPlugin& plugin );
			virtual ~Aip4cPlugin();

			const Aip4cPlugin& operator=( const Aip4cPlugin& plugin );

			bool load();
			const std::string& sharedObject() const;
			Aip4cWidget* createWidget( Aip4cComponents::Aip4cWindow* pparent );
			const PluginInfo& pluginInfo() const;
	};

	class Aip4cComponents_Export Aip4cPluginList : public std::vector<Aip4cPlugin>
	{
	};
}

#endif /* !__Aip4cComponents_Aip4cPlugin_h__ */
