#ifndef __Aip4cComponents_Aip4cWidget__
#define __Aip4cComponents_Aip4cWidget__

#include <Aip4cComponents/Aip4cComponents.h>
#include <Aip4cComponents/ToolBar.h>
#include <Aip4cComponents/PluginInfo.h>

#include <Auth4cData/AuthenticatedUser.h>

#include <QWidget>
#include <QString>
#include <QIcon>

#include <map>

class QMenuBar;
class QStatusBar;


namespace Aip4cComponents
{
	class Aip4cWindow;

	class Aip4cWidget : public QWidget
	{
		Q_OBJECT

		private:
			Aip4cWindow* _pparent;
			QMenuBar* _pmenuBar;
			QWidget* _pwdgCentral;
			ToolBarList _toolBarS;
			QString _strWindowTitle;
			QIcon _icon;
			bool _bAuthenticated;
			bool _bInitialized;
			PluginInfo _pluginInfo;

		public:
			Aip4cWidget( Aip4cWindow* pparent );
			virtual ~Aip4cWidget();

			Aip4cWindow* aipcWindow();

			const QString& windowTitle() const;
			const QIcon& windowIcon() const;
			const PluginInfo& pluginInfo() const;
			virtual QMenuBar* menuBar();
			virtual ToolBarList& toolBars();
			virtual void aboutToHide();
			virtual bool authenticateUser( const Auth4cData::AuthenticatedUser& user );
			virtual bool initialize( bool bAuthenticated );
			virtual bool canTerminate();
			virtual void terminate();

			void setMenuBar( QMenuBar* pmenu );
			void setCentralWidget( QWidget* pwidget );
			void setWindowTitle( const QString& strTitle );
			void setWindowIcon( const QIcon& icon );
			QStatusBar* statusBar();
			virtual void resizeEvent( QResizeEvent* pe );
			void addToolBar( QToolBar* ptoolBar );
			void addToolBar( Qt::ToolBarArea area, QToolBar* ptoolBar );
			void addToolBar( ToolBar* ptoolBar );
			QToolBar* addToolBar( const QString& strTitle );
			void removeToolBar( QToolBar* ptoolBar );
			void setStatusBar( QStatusBar* pstatus );
			void activateWindow();

		private:
			void setPluginInfo( const PluginInfo& info );

			friend class Aip4cWindow;
	};

	class Aip4cWidgetMap : public std::map<Aip4cWidget*, int>
	{
	};
}

#endif /* !__Aip4cComponents_Aip4cWidget__ */
