#ifndef __Aip4cComponents_Aip4cWindow_h__
#define __Aip4cComponents_Aip4cWindow_h__

#include <Aip4cComponents/Aip4cComponents.h>
#include <Aip4cComponents/Aip4cPlugin.h>
#include <Aip4cComponents/Settings.h>

#include <Auth4cClientConfig/Settings.h>
#include <Auth4cData/AuthenticatedUser.h>

#include <QMainWindow>

namespace Aip4cComponents
{
	class SplashWidget;

	class Aip4cComponents_Export Aip4cWindow : public QMainWindow
	{
		Q_OBJECT

		private:
			bool _bConstructed;
			QTabWidget* _ptabS;
			SplashWidget* _pwdgSplash;
			Aip4cComponents::Aip4cPluginList _pluginS;
			Aip4cComponents::Aip4cWidget* _pwidgetCurrent;
			Aip4cComponents::Aip4cWidgetMap _widgetS;
			QStatusBar* _pstatus;
			QToolBar* _ptoolBar;
			Settings _settingsAIP;
			Auth4cClientConfig::Settings _settingsAuth;
			bool _bAuthenticated;
			Auth4cData::AuthenticatedUser _user;
			static Aip4cWindow* _pwindow;
			QAction* _pactionAip4cSettings;
			QAction* _pactionAip4cInfo;
			QAction* _pactionAip4cExit;

		public:
			Aip4cWindow( QWidget *pparent = 0 );
			~Aip4cWindow();

			Settings& settingsAIP();
			Auth4cClientConfig::Settings& settingsAuth();
			void loadPlugins();
			bool authenticate();
			bool initialize();
			Aip4cComponents::Aip4cWidgetMap& widgets();
			void setTabTitle( Aip4cWidget* pwidget, const QString& strTitle );
			void setTabIcon( Aip4cWidget* pwidget, const QIcon& icon );
			void activateTab( Aip4cWidget* pwidget );
			static Aip4cWindow* theWindow();

		protected slots:
			void onCurrentTabChanged( int nTab );
			void onAip4cSettings();
			void onAip4cInfo();
			void onAip4cExit();

		protected:
			virtual void closeEvent( QCloseEvent* pe );
	};
}

#endif /* !__Aip4cComponents_Aip4cWindow_h__ */
