#ifndef __Aip4cComponents_Exception_h__
#define __Aip4cComponents_Exception_h__

#include <Aip4cComponents/Aip4cComponents.h>

#include <Base4c/Exception.h>

namespace Rfc
{
	class XMLNode;
}

namespace Aip4cComponents
{
	const int AIPX_BADCONFIG = Base4c::B4CX_DERIVEDBASE + 1;
	const int AIPX_PLUGINLOADFAIL = Base4c::B4CX_DERIVEDBASE + 11;
	const int AIPX_PLUGININFONULL = Base4c::B4CX_DERIVEDBASE + 12;
	const int AIPX_ALIENEXCEPTION = Base4c::B4CX_DERIVEDBASE + 21;
	const int AIPX_SEELEGEND = Base4c::B4CX_DERIVEDBASE + 31;
	const int AIPX_NOSUCHPRODUCT = Base4c::B4CX_DERIVEDBASE + 41;

	class Aip4cComponents_Export Exception : public Base4c::Exception
	{
		public:
			Exception( int nErrorCode, bool bFatal = false, const std::string& strLegend = std::string() );
			Exception( const std::string& strFile, int nLine, int nErrorCode, bool bFatal = false, const std::string& strLegend = std::string() );
			Exception( const Exception& exception );
			Exception( const Base4c::Exception& exception );
			virtual ~Exception();

			const Exception& operator=( const Exception& exception );

			static const std::string explainErrorCode( int nErrorCode );

			void toXML( Rfc::XMLNode* pnodeParent ) const;

			static Exception fromXML( const Rfc::XMLNode* pnodeParent );

		protected:
			Exception();
	};
};

Aip4cComponents_Export std::ostream& operator<<( std::ostream& stream, const Aip4cComponents::Exception& e );

#endif /* !__Aip4cComponents_Exception_h__ */
