#ifndef __Aip4cComponents_PluginInfo_h__
#define __Aip4cComponents_PluginInfo_h__

#include <Aip4cComponents/Aip4cComponents.h>

#include <Base4c/Version.h>

#include <set>

namespace Aip4cComponents
{
	class Aip4cComponents_Export PluginInfo
	{
		public:
			class Aip4cComponents_Export DependencyList : public std::set<int>
			{
			};

		private:
			int _nProductId;
			std::string _strProductName;
			Base4c::Version _version;
			DependencyList _dependencyS;

		public:
			PluginInfo();
			PluginInfo( int nProductId, const std::string& strProductName, const Base4c::Version& version, const DependencyList& dependencyS = DependencyList() );
			PluginInfo( const PluginInfo& info );
			virtual ~PluginInfo();

			const PluginInfo& operator=( const PluginInfo& info );

			int productId() const;
			const std::string& productName() const;
			const Base4c::Version& version() const;
			const DependencyList& dependencies() const;
	};
}

#endif /* !__Aip4cComponents_PluginInfo_h__ */
