#ifndef __Aip4cComponents_SettingsDialog_h__
#define __Aip4cComponents_SettingsDialog_h__

#include <Aip4cComponents/Aip4cComponents.h>
#include <Aip4cComponents/Settings.h>

#include <QDialog>
#include <ui_SettingsDialog.h>

namespace Aip4cComponents
{
	class Aip4cComponents_Export aip4cSettingsDialog : public QDialog, private Ui::aip4cSettingsDialog
	{
		Q_OBJECT

		private:
			Settings& _settings;

		public:
			aip4cSettingsDialog( QWidget* pparent, Settings& settings );
			virtual ~aip4cSettingsDialog();

		protected slots:
			void accept();
			void reject();
			void onUp();
			void onDn();
			void onOpen();
			void onDblClickPlugin( QListWidgetItem* pitem );
			void onDblClickTab( QListWidgetItem* pitem );

		protected:
			void load();
			void registerPlugin( const QString& strFile );
			virtual void dragEnterEvent( QDragEnterEvent* pe );
			virtual void dropEvent( QDropEvent* pe );
	};
};

#endif /* !__Aip4cComponents_SettingsDialog_h__ */
